# helper script that generates AllObjects.h file
#
# for the object to be included in AllObjects.h, they must have a create function in this format:
# ObjectStruct* <whatever_you_want>Create();
# 

import sys
import os
import time
from collections import namedtuple

#object_id, create function, number of parameters, header filename

ObjectInfo = namedtuple('ObjectInfo', 'headerfilename, objectidname, createfunction, numberofparameters')
objectInfos = []

from glob import glob
print "************** Generating AllObjects.h and Spawn Level Object function **************"
filenames = glob('Objects\*.h')


def exportheader():
    global objectInfos
    file = open("generated\\AllObjects.h", "w")
    file.write("// **************************************************** \n")
    file.write("// This file is automatically generated by\n")
    file.write("// generate_object_helpers.py\n")
    file.write("// **************************************************** \n\n")
    file.write('#ifndef ALL_OBJECTS_INCLUDE_H\n')
    file.write('#define ALL_OBJECTS_INCLUDE_H\n\n')
    
    for objectInfo in objectInfos:
        file.write('#include "..\\' + objectInfo.headerfilename + '"\n')

    file.write('\n#endif\n')
    file.close()  

for filename in filenames:
    object_id = ''
    createfunction = ''
    createfunctionparameters = ''
    numberofparameters = 0
    file = open(filename)
    content = file.read()
#object id
    startindex = content.find("OBJECT_ID") 
    if startindex != -1:
        endindex = content.find(" ", startindex)
        object_id = content[startindex:endindex]
#function name
    startindex = content.find("ObjectStruct*")
    if startindex != -1:    
        startindex = content.find(" ", startindex)
        startindex = startindex + 1
        endindex = content.find("(", startindex)
        createfunction = content[startindex:endindex]
        createfunctionparameters = content[endindex:content.find(')')]

#number of parameters
    numberofparameters = createfunctionparameters.count(',')  + 1

#create object info
    if createfunction != '':
        objectInfo = ObjectInfo(filename, object_id, createfunction, numberofparameters)
        objectInfos.append(objectInfo)

exportheader()

