#include "ComplexAnimationDraw.h"

#include "Debug.h"
#include "vdp_spr.h"
#include "exported\ExportedGGAnimations.h"
#include "VDP_Extra.h"


void ComplexAnimation_Draw(s16 x, s16 y, const ComplexAnimation* animation, u16 frameNumber, u16 direction, u16 palette)
{
    u16 loop = 0;

    const ComplexAnimationPart* parts = animation->parts;

    for (loop = animation->numParts; loop > 0; loop--)
    {
        const GGAnimation* animationGG = parts->ggAnimation;

        u16 innerLoop = 0;
        u16 tileInfo = TILE_ATTR_FULL(palette, 0, 0, direction, animationGG->vdpInfo->startIndex);
        const GGFrame* frame = *(animationGG->frames + frameNumber);
        const GGSprite* sprite = *(frame->sprites);

        for (innerLoop = frame->numSprites; innerLoop > 0; innerLoop--)
        {
            if (spriteDrawIndex >= MAX_SPRITE) return;

            if (direction == DIRECTION_RIGHT)
            {
                currentSpriteDef->posx = x + parts->x + sprite->xoffset;
            }
            else
            {
                currentSpriteDef->posx = x + parts->x + animationGG->width - (sprite->xoffset + (sprite->tilewidth << 3));
            }

            currentSpriteDef->posy = y + parts->y + sprite->yoffset;
            currentSpriteDef->tile_attr = tileInfo + sprite->VDPTileOffset;
            currentSpriteDef->size = sprite->sgdkSpriteSize;
            spriteDrawIndex++;
            currentSpriteDef->link = spriteDrawIndex;
            currentSpriteDef++;

            sprite++;
        }


        parts++;
    }
}

