#include "Debug.h"

#include <kdebug.h>

void PrintNumber(u32 value)
{
    KDebug_AlertNumber(value);
}

void Print(char* message)
{
    KDebug_Alert(message);
}

void PrintSprite(const SpriteDef* sprite)
{
    PrintNumber(sprite->posx);
    PrintNumber(sprite->posy);
    PrintNumber(sprite->tile_attr);
    PrintNumber(sprite->size);
    PrintNumber(sprite->link);
}

void PrintObjectStruct(ObjectStruct* objectStruct)
{
    Print("****** OBJECT *******");
    PrintSprite(&objectStruct->spritedef);
    PrintNumber(objectStruct->x);
    PrintNumber(objectStruct->y);
    PrintNumber((u32)objectStruct->updateFunction);
    PrintNumber((u32)objectStruct->destroyFunction);
    PrintNumber((u32)objectStruct->drawFunction);
    PrintNumber((u32)objectStruct->collisionFunction);
    PrintNumber(objectStruct->objectState);
    PrintNumber(objectStruct->aiState);
    PrintNumber(objectStruct->speedx);
    PrintNumber(objectStruct->speedy);
    PrintNumber(objectStruct->lifetime);
    PrintNumber(objectStruct->objectType);
    PrintNumber(objectStruct->rectLeft);
    PrintNumber(objectStruct->rectRight);
    PrintNumber(objectStruct->rectTop);
    PrintNumber(objectStruct->rectBottom);
    PrintNumber(objectStruct->healthPoints);
    PrintNumber(objectStruct->damage);
    Print("*********************");
}

void PrintAPLAN(u32 value, u16 x, u16 y)
{
    char tempString[16];
    intToStr(value, tempString, 16);
    VDP_drawText(tempString, x, y);
}

void ErrorMessage(const char* message)
{
    VDP_init();
    VDP_drawText("Error!", 0, 0);
    VDP_drawText(message, 0, 1);

    while(1);
}

void Assert(u16 condition, const char* message)
{
    if (!condition)
    {
        VDP_init();
        VDP_drawText("Assert!", 0, 0);
        VDP_drawText(message, 0, 1);

        while(1);
    }
}
