#ifndef SCROLL_MANAGER_INCLUDE_H
#define SCROLL_MANAGER_INCLUDE_H

#include <genesis.h>

#include "Map.h"

// defines the size used around the player to update background tiles for scrolling.
#define TILE_UPDATE_AREA_WIDTH              (SCREEN_WIDTH_IN_TILES  + 2) 
#define TILE_UPDATE_AREA_HEIGHT             (SCREEN_HEIGHT_IN_TILES + 2)
#define TILE_UPDATE_AREA_HALF_WIDTH         (TILE_UPDATE_AREA_WIDTH >> 1)
#define TILE_UPDATE_AREA_HALF_HEIGHT        (TILE_UPDATE_AREA_HEIGHT >> 1)

typedef struct
{
    s32 scrollx_hires;
    s32 scrolly_hires;
    s32 scrollx_hires_limit;
    s32 scrolly_hires_limit;
    s32 scrollx_hires_clamped;
    s32 scrolly_hires_clamped;
    s16 scrollx_vdp;
    s16 scrolly_vdp;
    u16 cameraShakeTimer;
} ScrollDataStruct;

extern ScrollDataStruct foregroundScrollData;
extern ScrollDataStruct backgroundScrollData;

void ScrollManager_Init();
void ScrollManager_Update();
void ScrollManager_UpdateVDP();
void ScrollManager_Refresh();

void ScrollManager_SetCameraShakeTime(u16 time);

#endif
