#include <genesis.h>

#include "Debug.h"
#include "generated\DebugSettings.h"
#include "GameFont.h"
#include "TitleScreen.h"
#include "JoypadManager.h"
#include "LevelManager.h"
#include "StateManager.h"
#include "VDP_Extra.h"

//#define SHOW_TITLE_SCREEN

void SetupSystem()
{
    VDP_init();
    VDP_setScreenHeight224();
    VDP_setScreenWidth320();
    JOY_init();


    VDP_loadFontData((const u32 *)gameFont, FONT_LEN, 1);

    DebugSettings_Init();
    JoypadManager_Init();
}


int main()
{
    SetupSystem();

#ifdef SHOW_TITLE_SCREEN
    TitleScreen_Start();
#else
    LevelManager_Init();
#endif
    while (1)
    {
        JoypadManager_UpdateJoypad();
        StateManager_CurrentState();
    }
}

